package com.blamejared.compat.botania.handlers;

import java.util.Iterator;
import crafttweaker.CraftTweakerAPI;
import java.util.Collection;
import com.blamejared.mtlib.helpers.StackHelper;
import java.util.LinkedList;
import com.blamejared.mtlib.utils.BaseListRemoval;
import com.blamejared.mtlib.helpers.LogHelper;
import java.util.List;
import java.util.Collections;
import vazkii.botania.api.BotaniaAPI;
import com.blamejared.mtlib.utils.BaseListAddition;
import stanhebben.zenscript.annotations.ZenMethod;
import vazkii.botania.api.recipe.RecipeRuneAltar;
import com.blamejared.mtlib.helpers.InputHelper;
import com.blamejared.ModTweaker;
import crafttweaker.api.item.IIngredient;
import crafttweaker.api.item.IItemStack;
import crafttweaker.annotations.ZenRegister;
import crafttweaker.annotations.ModOnly;
import stanhebben.zenscript.annotations.ZenClass;

@ZenClass("mods.botania.RuneAltar")
@ModOnly("botania")
@ZenRegister
public class RuneAltar
{
    protected static final String name = "Botania Rune Altar";
    
    @ZenMethod
    public static void addRecipe(final IItemStack output, final IIngredient[] input, final int mana) {
        ModTweaker.LATE_ADDITIONS.add(new Add(new RecipeRuneAltar(InputHelper.toStack(output), mana, InputHelper.toObjects(input))));
    }
    
    @ZenMethod
    public static void removeRecipe(final IIngredient output) {
        ModTweaker.LATE_REMOVALS.add(new Remove(output));
    }
    
    private static class Add extends BaseListAddition<RecipeRuneAltar>
    {
        public Add(final RecipeRuneAltar recipe) {
            super("Botania Rune Altar", BotaniaAPI.runeAltarRecipes, (List)Collections.singletonList(recipe));
        }
        
        public String getRecipeInfo(final RecipeRuneAltar recipe) {
            return LogHelper.getStackDescription((Object)recipe.getOutput());
        }
    }
    
    private static class Remove extends BaseListRemoval<RecipeRuneAltar>
    {
        final IIngredient output;
        
        public Remove(final IIngredient output) {
            super("Botania Rune Altar", BotaniaAPI.runeAltarRecipes);
            this.output = output;
        }
        
        public String getRecipeInfo(final RecipeRuneAltar recipe) {
            return LogHelper.getStackDescription((Object)recipe.getOutput());
        }
        
        public void apply() {
            final List<RecipeRuneAltar> recipes = new LinkedList<RecipeRuneAltar>();
            for (final RecipeRuneAltar r : BotaniaAPI.runeAltarRecipes) {
                if (r != null && r.getOutput() != null && StackHelper.matches(this.output, InputHelper.toIItemStack(r.getOutput()))) {
                    recipes.add(r);
                }
            }
            if (!recipes.isEmpty()) {
                this.recipes.addAll(recipes);
                super.apply();
            }
            else {
                LogHelper.logWarning(String.format("No %s Recipe found for %s. Command ignored!", "Botania Rune Altar", this.output.toString()));
            }
            CraftTweakerAPI.getLogger().logInfo(super.describe());
        }
        
        public String describe() {
            return "Attempting to remove Rune Altar recipe for " + this.output.getItems();
        }
    }
}
